Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# ByteQueue Class Reference

`#include <queue.h>`

Inheritance diagram for ByteQueue:

List of all members.

## Detailed Description

Byte Queue.

Definition at line 16 of file queue.h.

## SIGNALS
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transfered signals
virtual int | GetAutoSignalPropagation () const
## ATTACHMENT
virtual bool | Attachable ()
| returns whether this object allows attachment
virtual BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
virtual const BufferedTransformation * | AttachedTransformation () const
virtual void | Detach (BufferedTransformation *newAttachment=0)
| delete the current attachment chain and replace it with newAttachment
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Public Member Functions
| ByteQueue (unsigned int m_nodeSize=256)
| ByteQueue (const ByteQueue &copy)
unsigned long | MaxRetrievable () const
| returns number of bytes that is currently ready for retrieval
bool | AnyRetrievable () const
| returns whether any bytes are currently ready for retrieval
void | IsolatedInitialize (const NameValuePairs &parameters)
byte * | CreatePutSpace (unsigned int &size)
| request space to write bytes into for processing
unsigned int | Put2 (const byte *inString, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
unsigned int | Get (byte &outByte)
| try to retrieve a single byte
unsigned int | Get (byte *outString, unsigned int getMax)
| try to retrieve multiple bytes
unsigned int | Peek (byte &outByte) const
| peek at the next byte without removing it from the output buffer
unsigned int | Peek (byte *outString, unsigned int peekMax) const
| peek at multiple bytes without removing them from the output buffer
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
void | SetNodeSize (unsigned int nodeSize)
unsigned long | CurrentSize () const
bool | IsEmpty () const
void | Clear ()
void | Unget (byte inByte)
void | Unget (const byte *inString, unsigned int length)
const byte * | Spy (unsigned int &contiguousSize) const
void | LazyPut (const byte *inString, unsigned int size)
void | UndoLazyPut (unsigned int size)
void | FinalizeLazyPut ()
ByteQueue & | operator= (const ByteQueue &rhs)
bool | operator== (const ByteQueue &rhs) const
byte | operator[] (unsigned long i) const
void | swap (ByteQueue &rhs)
bool | IsolatedFlush (bool hardFlush, bool blocking)
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Static Protected Member Functions
int | DecrementPropagation (int propagation)
## Friends
class | Walker

## Member Function Documentation

unsigned long ByteQueue::MaxRetrievable | ( |  | ) | const`[inline, virtual]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented from BufferedTransformation. Definition at line 23 of file queue.h.

byte * ByteQueue::CreatePutSpace | ( | unsigned int & | size | ) | `[virtual]`

  | request space to write bytes into for processing Parameters:
  size | is requested size (as a hint) for input, and size of the returned space for output
Reimplemented from BufferedTransformation. Definition at line 371 of file queue.cpp.

unsigned int ByteQueue::Put2 | ( | const byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[virtual]`

  | input multiple bytes for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Implements BufferedTransformation. Definition at line 209 of file queue.cpp.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 702 of file cryptlib.h.

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in FilterWithBufferedInput. Definition at line 738 of file cryptlib.h.

bool BufferedTransformation::Flush | ( | bool | hardFlush,
|  | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

  | flush buffered input and/or output Parameters:
  hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Reimplemented in Filter, Redirector, SecretSharing, and InformationDispersal. Definition at line 169 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

bool BufferedTransformation::MessageSeriesEnd | ( | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented in Filter, and Redirector. Definition at line 175 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| set propagation of automatically generated and transfered signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, and SourceTemplate< StringStore >. Definition at line 778 of file cryptlib.h.

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 318 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

virtual bool BufferedTransformation::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented in Filter. Definition at line 926 of file cryptlib.h. Referenced by BufferedTransformation::Attach().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 101 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following files:

- queue.h
- queue.cpp